var myinput = new function () {
  /*
 文字を入力するとicに追加され、キーに対応する文字を出力する。
 キーに対応するエントリがあるうちは出力した文字を消して上書き。
 キーが尽きたらそこで確定する。
 後続のあるキーは1文字以上設定する必要がある。
 特に何も表示したくなかったら key : ['key'] で。
 key : string // 文字を表示
 key : [string , scr-name , flag] // key を string に変更
 flag&1 // wf = 0
 flag&2 // wf = 1
 // 両方は wf をトグル
 flag&4  // af = 0
 flag&8 // af = 1
 // 両方は af をトグル
 // w->a の順なので、そのように適用してうまくいくようにフィルタを設定する。
 flag&16 // 一時モード: root を key に設定 , @ で af wf 変更前に戻す
   */
  var innermap = sirius.require('ibuki.js');
  var widthmap = sirius.require('widthmap.js');
  var altmap = sirius.require('altmap.js');
  var root="";
  var key=root;
  var len=0;
  var wf = 0;
  var af = 0;
  var roots = ["","a"];
  var root_n = 0;
  var tempf = 0;
  // 文字のみ配置されたキーに達したときrootに戻る(枝は全て配列で指定)
  var strict = true;

  //help用
  var innerchar = [
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","","","","","",
    " ","","","","","","","","","","","",",","-",".","/",
    "0","1","2","3","4","5","6","7","8","9",":",";","","","","",
    "@","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o",
    "p","q","r","s","t","u","v","w","x","y","z","[","\\","]","^","",
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","",":",";",",","-",".","/",
    "@","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","[","","]","^","",
    "","","","","","","","","","","","","","","","",
    "","","","","","","","","","","","","","","",""
    ];

  this.getInnerStr = function (code) {
    var s = innerchar[code];
    if (!s) return ""; // ない
    var k = key+s;
    k = innermap[k];
    if (k) return k; // ある
    k = root+s; // keyがないならrootで調べる
    k = innermap[k];
    return k;
  }

  this.key = function (code) { return key;}

  function input (x) {
    var k = key+x;
    var q = 0;
    if (innermap[k]) { // 継続入力
      q = len; // 前の字は消す。
      if(typeof innermap[k] == "string") key = k;
      else {
        key = innermap[k][0];
        if (innermap[k][2] & 16){
          root = key;
          if (!tempf) tempf = 1 + af*2 + wf*4;
        }
        switch (innermap[k][2] & 3) {
        case 1: wf = 0;break;
        case 2: wf = 1;break;
        case 3: wf = 1 - wf;
        }
        switch (innermap[k][2] & 12) {
        case 4: af = 0;break;
        case 8: af = 1;break;
        case 12: af = 1 - af;
        }
      }
      var s = innermap[key];
      if (typeof s == "string") {
        if (wf) s = filter(s,widthmap);
        if (af) s = filter(s,altmap);
        if (strict) {
          key = root;len = 0;
        } else len = s.length;
      } else {
        s = ""; len = 0;}
      sirius.imeSend(s,q);
    } else {
      if (x) { // 新規文字
        key = root+x;len = 0;
        input("");
      }
    }
  }

  function filter (str,ftr) {
    var out = "";
    for (var i = 0; i < str.length; i++) {
      var c = str.substr(i, 1);
      if (ftr[c]) out += ftr[c];
      else out += c;
    }
    return out;
  }

  //external
  this.filter = function (str) {
    if (wf) str = filter(str,widthmap);
    if (af) str = filter(str,altmap);
    return str;
  }

  //key:C-h
  this.back = function () {
    if (sirius.imeString) {
      if (key) {
        sirius.imeSend("",len);
        key = root;len=0;
      } else sirius.imeSend("",1);
    } else sirius.send('', sirius.vk('VK_BACK'));
  }

  //key:S-@
  this.reset = function () {
    root_n = 0;
    root = roots[root_n];
    key = "";
    len = 0;
    wf = 0;
    af = 0;
    tempf = 0;
  }

  //key:S-[
  this.Sreset = function () {
    root = "(S+)";
    key = "";
    len = 0;
    wf = 0;
    af = 0;
    tempf = 0;
  }

  //key:@
  this.rootChange = function () {
    var f = -1;
    var k;
    if (tempf) {
      af = tempf&2 ? 1 : 0;
      wf = tempf&4 ? 1 : 0;
      tempf = 0;
    }
    if (key==root) { // root にいるとき
      for (var i=0;i<roots.length;i++) {
        // root が roots にあるときはrootsの次に移動
        if (root==roots[i]) { f = i+1;break;}
      }
      if (!(f==-1)) {root_n = f;}
      if (!roots[root_n]) root_n = 0;
      root = roots[root_n];
      key = root;len = 0;
    } else { // root にいないとき、後続が存在すれば key を root にする
      f = 0;
      for (var i=0;i<innerchar.length;i++) {
        if (innerchar[i]){
          k = key+innerchar[i];
          if (innermap[k]) {f=1;break;}
        }}
      if (f) root = key;
      else { // そうでないなら root へ戻る
        root = roots[root_n];
        key = root; len = 0;
      }
    }}


  //inputkeys
  this.input_q = function (){input('q');}
  this.input_w = function (){input('w');}
  this.input_e = function (){input('e');}
  this.input_r = function (){input('r');}
  this.input_t = function (){input('t');}
  this.input_y = function (){input('y');}
  this.input_u = function (){input('u');}
  this.input_i = function (){input('i');}
  this.input_o = function (){input('o');}
  this.input_p = function (){input('p');}
  this.input_a = function (){input('a');}
  this.input_s = function (){input('s');}
  this.input_d = function (){input('d');}
  this.input_f = function (){input('f');}
  this.input_g = function (){input('g');}
  this.input_h = function (){input('h');}
  this.input_j = function (){input('j');}
  this.input_k = function (){input('k');}
  this.input_l = function (){input('l');}
  this.input_semicolon = function (){input(';');}
  this.input_z = function (){input('z');}
  this.input_x = function (){input('x');}
  this.input_c = function (){input('c');}
  this.input_v = function (){input('v');}
  this.input_b = function (){input('b');}
  this.input_n = function (){input('n');}
  this.input_m = function (){input('m');}
  this.input_camma = function (){input(',');}
  this.input_dot = function (){input('.');}
  this.input_slash = function (){input('/');}
  //
  this.input_colon = function (){input(':');}
  this.input_closebracket = function (){input(']');}
  //Sinput
  this.input_Sq = function (){input('(S+)q');}
  this.input_Sw = function (){input('(S+)w');}
  this.input_Se = function (){input('(S+)e');}
  this.input_Sr = function (){input('(S+)r');}
  this.input_St = function (){input('(S+)t');}
  this.input_Sy = function (){input('(S+)y');}
  this.input_Su = function (){input('(S+)u');}
  this.input_Si = function (){input('(S+)i');}
  this.input_So = function (){input('(S+)o');}
  this.input_Sp = function (){input('(S+)p');}
  this.input_Sa = function (){input('(S+)a');}
  this.input_Ss = function (){input('(S+)s');}
  this.input_Sd = function (){input('(S+)d');}
  this.input_Sf = function (){input('(S+)f');}
  this.input_Sg = function (){input('(S+)g');}
  this.input_Sh = function (){input('(S+)h');}
  this.input_Sj = function (){input('(S+)j');}
  this.input_Sk = function (){input('(S+)k');}
  this.input_Sl = function (){input('(S+)l');}
  this.input_Ssemicolon = function (){input('(S+);');}
  this.input_Sz = function (){input('(S+)z');}
  this.input_Sx = function (){input('(S+)x');}
  this.input_Sc = function (){input('(S+)c');}
  this.input_Sv = function (){input('(S+)v');}
  this.input_Sb = function (){input('(S+)b');}
  this.input_Sn = function (){input('(S+)n');}
  this.input_Sm = function (){input('(S+)m');}
  this.input_Scamma = function (){input('(S+),');}
  this.input_Sdot = function (){input('(S+).');}
  this.input_Sslash = function (){input('(S+)/');}
  //
  this.input_Scolon = function (){input('(S+):');}
  this.input_Sclosebracket = function (){input('(S+)]');}
}

//息吹主配置 'S-IME+IMESTR/'
var map_myinput = [
  assign('', 'q', myinput.input_q),
  assign('', 'w', myinput.input_w),
  assign('', 'e', myinput.input_e),
  assign('', 'r', myinput.input_r),
  assign('', 't', myinput.input_t),
  assign('', 'y', myinput.input_y),
  assign('', 'u', myinput.input_u),
  assign('', 'i', myinput.input_i),
  assign('', 'o', myinput.input_o),
  assign('', 'p', myinput.input_p),
  assign('', 'a', myinput.input_a),
  assign('', 's', myinput.input_s),
  assign('', 'd', myinput.input_d),
  assign('', 'f', myinput.input_f),
  assign('', 'g', myinput.input_g),
  assign('', 'h', myinput.input_h),
  assign('', 'j', myinput.input_j),
  assign('', 'k', myinput.input_k),
  assign('', 'l', myinput.input_l),
  assign('', 'jp-;', myinput.input_semicolon),
  assign('', 'z', myinput.input_z),
  assign('', 'x', myinput.input_x),
  assign('', 'c', myinput.input_c),
  assign('', 'v', myinput.input_v),
  assign('', 'b', myinput.input_b),
  assign('', 'n', myinput.input_n),
  assign('', 'm', myinput.input_m),
  assign('', 'jp-,', myinput.input_camma),
  assign('', 'jp-.', myinput.input_dot),
  assign('', 'jp-/', myinput.input_slash),
  assign('', 'jp-:', myinput.input_colon),
  assign('', 'jp-]', myinput.input_closebracket),
  assign('', 'VK_BACK', myinput.back),
  assign('', 'jp-@', myinput.rootChange),
  assignVk('', 'jp-[' , '', 'VK_NONCONVERT'), //toggleConvert
  ];

//息吹シフト側 'S+IME+IMESTR/'
var map_mySinput = [
  assign('', 'q', myinput.input_Sq),
  assign('', 'w', myinput.input_Sw),
  assign('', 'e', myinput.input_Se),
  assign('', 'r', myinput.input_Sr),
  assign('', 't', myinput.input_St),
  assign('', 'y', myinput.input_Sy),
  assign('', 'u', myinput.input_Su),
  assign('', 'i', myinput.input_Si),
  assign('', 'o', myinput.input_So),
  assign('', 'p', myinput.input_Sp),
  assign('', 'a', myinput.input_Sa),
  assign('', 's', myinput.input_Ss),
  assign('', 'd', myinput.input_Sd),
  assign('', 'f', myinput.input_Sf),
  assign('', 'g', myinput.input_Sg),
  assign('', 'h', myinput.input_Sh),
  assign('', 'j', myinput.input_Sj),
  assign('', 'k', myinput.input_Sk),
  assign('', 'l', myinput.input_Sl),
  assign('', 'jp-;', myinput.input_Ssemicolon),
  assign('', 'z', myinput.input_Sz),
  assign('', 'x', myinput.input_Sx),
  assign('', 'c', myinput.input_Sc),
  assign('', 'v', myinput.input_Sv),
  assign('', 'b', myinput.input_Sb),
  assign('', 'n', myinput.input_Sn),
  assign('', 'm', myinput.input_Sm),
  assign('', 'jp-,', myinput.input_Scamma),
  assign('', 'jp-.', myinput.input_Sdot),
  assign('', 'jp-/', myinput.input_Sslash),
  assign('', 'jp-:', myinput.input_Scolon),
  assign('', 'jp-]', myinput.input_Sclosebracket),
  assign('', 'jp-@', myinput.reset),
  assign('', 'jp-[', myinput.Sreset),
  ];

//otherkey
//  assign('C+IME+IMESTR/', 'h', myinput.back), //後退(or キー解除)

